# Ipopt::CachedResults< T > Class Template Reference

Cache Priority Enum. More...

`#include <IpCachedResults.hpp>`

Inheritance diagram for Ipopt::CachedResults< T >:
[legend]

List of all members.

## Public Member Functions
bool | InvalidateResult (const std::vector< const TaggedObject * > &dependents, const std::vector< Number > &scalar_dependents)
| Invalidates the result for given dependencies.
void | Clear ()
| Invalidates all cached results.
void | Clear (Int max_cache_size)
| Invalidate all cached results and changes max_cache_size.
Constructors and Destructors.
| CachedResults (Int max_cache_size)
| Constructor, where max_cache_size is the maximal number of results that should be cached.
virtual | ~CachedResults ()
| Destructor.
Generic methods for adding and retrieving cached results.
void | AddCachedResult (const T &result, const std::vector< const TaggedObject * > &dependents, const std::vector< Number > &scalar_dependents)
| Generic method for adding a result to the cache, given a std::vector of TaggesObjects and a std::vector of Numbers.
bool | GetCachedResult (T &retResult, const std::vector< const TaggedObject * > &dependents, const std::vector< Number > &scalar_dependents) const
| Generic method for retrieving a cached results, given the dependencies as a std::vector of TaggesObjects and a std::vector of Numbers.
void | AddCachedResult (const T &result, const std::vector< const TaggedObject * > &dependents)
| Method for adding a result, providing only a std::vector of TaggedObjects.
bool | GetCachedResult (T &retResult, const std::vector< const TaggedObject * > &dependents) const
| Method for retrieving a cached result, providing only a std::vector of TaggedObjects.
Pointer-based methods for adding and retrieving cached
results, providing dependencies explicitly.
void | AddCachedResult1Dep (const T &result, const TaggedObject *dependent1)
| Method for adding a result to the cache, proving one dependency as a TaggedObject explicitly.
bool | GetCachedResult1Dep (T &retResult, const TaggedObject *dependent1)
| Method for retrieving a cached result, proving one dependency as a TaggedObject explicitly.
void | AddCachedResult2Dep (const T &result, const TaggedObject *dependent1, const TaggedObject *dependent2)
| Method for adding a result to the cache, proving two dependencies as a TaggedObject explicitly.
bool | GetCachedResult2Dep (T &retResult, const TaggedObject *dependent1, const TaggedObject *dependent2)
| Method for retrieving a cached result, proving two dependencies as a TaggedObject explicitly.
void | AddCachedResult3Dep (const T &result, const TaggedObject *dependent1, const TaggedObject *dependent2, const TaggedObject *dependent3)
| Method for adding a result to the cache, proving three dependencies as a TaggedObject explicitly.
bool | GetCachedResult3Dep (T &retResult, const TaggedObject *dependent1, const TaggedObject *dependent2, const TaggedObject *dependent3)
| Method for retrieving a cached result, proving three dependencies as a TaggedObject explicitly.
Pointer-free version of the Add and Get methods
bool | GetCachedResult1Dep (T &retResult, const TaggedObject &dependent1)
bool | GetCachedResult2Dep (T &retResult, const TaggedObject &dependent1, const TaggedObject &dependent2)
bool | GetCachedResult3Dep (T &retResult, const TaggedObject &dependent1, const TaggedObject &dependent2, const TaggedObject &dependent3)
void | AddCachedResult1Dep (const T &result, const TaggedObject &dependent1)
void | AddCachedResult2Dep (const T &result, const TaggedObject &dependent1, const TaggedObject &dependent2)
void | AddCachedResult3Dep (const T &result, const TaggedObject &dependent1, const TaggedObject &dependent2, const TaggedObject &dependent3)
## Private Member Functions
void | CleanupInvalidatedResults () const
| internal method for removing stale DependentResults from the list.
void | DebugPrintCachedResults () const
| Print list of currently cached results.
Default Compiler Generated Methods
(Hidden to avoid implicit creation/calling). These methods are not implemented and we do not want the compiler to implement them for us, so we declare them private and do not define them. This ensures that they will not be implicitly created/called.
| CachedResults ()
| Default Constructor.
| CachedResults (const CachedResults &)
| Copy Constructor.
void | operator= (const CachedResults &)
| Overloaded Equals Operator.
## Private Attributes
Int | max_cache_size_
| maximum number of cached results
std::list< DependentResult< T > * > * | cached_results_
| list of currently cached results.

## Detailed Description

### template<class T>
class Ipopt::CachedResults< T >

Cache Priority Enum.

Templated class for Cached Results. This class stores up to a given number of "results", entities that are stored here together with identifiers, that can be used to later retrieve the information again.

Typically, T is a SmartPtr for some calculated quantity that should be stored (such as a Vector). The identifiers (or dependencies) are a (possibly varying) number of Tags from TaggedObjects, and a number of Numbers. Results are added to the cache using the AddCachedResults methods, and the can be retrieved with the GetCachedResults methods. The second set of methods checks whether a result has been cached for the given identifiers. If a corresponding result is found, a copy of it is returned and the method evaluates to true, otherwise it evaluates to false.

Note that cached results can become "stale", namely when a TaggedObject that is used to identify this CachedResult is changed. When this happens, the cached result can never be asked for again, so that there is no point in storing it any longer. For this purpose, a cached result, which is stored as a DependentResult, inherits off an Observer. This Observer retrieves notification whenever a TaggedObject dependency has changed. Stale results are later removed from the cache.

Definition at line 70 of file IpCachedResults.hpp.

## Constructor & Destructor Documentation

template<class T >

Ipopt::CachedResults< T >::CachedResults | ( | Int | max_cache_size | ) | `[inline]`

Constructor, where max_cache_size is the maximal number of results that should be cached.

If max_cache_size is negative, we allow an infinite amount of cache.

Definition at line 476 of file IpCachedResults.hpp.

template<class T >

Ipopt::CachedResults< T >::~CachedResults | ( |  | ) | `[inline, virtual]`

Destructor.

Definition at line 488 of file IpCachedResults.hpp.

template<class T>

Ipopt::CachedResults< T >::CachedResults | ( |  | ) | `[private]`

Default Constructor.

template<class T>

Ipopt::CachedResults< T >::CachedResults | ( | const CachedResults< T > & |  | ) | `[private]`

Copy Constructor.

## Member Function Documentation

template<class T>

void Ipopt::CachedResults< T >::AddCachedResult | ( | const T & | result,
|  | const std::vector< const TaggedObject * > & | dependents,
|  | const std::vector< Number > & | scalar_dependents |
| ) |  |  | `[inline]`

Generic method for adding a result to the cache, given a std::vector of TaggesObjects and a std::vector of Numbers.

Definition at line 513 of file IpCachedResults.hpp.

template<class T>

bool Ipopt::CachedResults< T >::GetCachedResult | ( | T & | retResult,
|  | const std::vector< const TaggedObject * > & | dependents,
|  | const std::vector< Number > & | scalar_dependents |
| ) |  |  | const`[inline]`

Generic method for retrieving a cached results, given the dependencies as a std::vector of TaggesObjects and a std::vector of Numbers.

Definition at line 555 of file IpCachedResults.hpp.

template<class T>

void Ipopt::CachedResults< T >::AddCachedResult | ( | const T & | result,
|  | const std::vector< const TaggedObject * > & | dependents |
| ) |  |  | `[inline]`

Method for adding a result, providing only a std::vector of TaggedObjects.

Definition at line 547 of file IpCachedResults.hpp.

template<class T>

bool Ipopt::CachedResults< T >::GetCachedResult | ( | T & | retResult,
|  | const std::vector< const TaggedObject * > & | dependents |
| ) |  |  | const`[inline]`

Method for retrieving a cached result, providing only a std::vector of TaggedObjects.

Definition at line 585 of file IpCachedResults.hpp.

template<class T>

void Ipopt::CachedResults< T >::AddCachedResult1Dep | ( | const T & | result,
|  | const TaggedObject * | dependent1 |
| ) |  |  | `[inline]`

Method for adding a result to the cache, proving one dependency as a TaggedObject explicitly.

Definition at line 593 of file IpCachedResults.hpp.

template<class T>

bool Ipopt::CachedResults< T >::GetCachedResult1Dep | ( | T & | retResult,
|  | const TaggedObject * | dependent1 |
| ) |  |  | `[inline]`

Method for retrieving a cached result, proving one dependency as a TaggedObject explicitly.

Definition at line 607 of file IpCachedResults.hpp.

template<class T>

void Ipopt::CachedResults< T >::AddCachedResult2Dep | ( | const T & | result,
|  | const TaggedObject * | dependent1,
|  | const TaggedObject * | dependent2 |
| ) |  |  | `[inline]`

Method for adding a result to the cache, proving two dependencies as a TaggedObject explicitly.

Definition at line 620 of file IpCachedResults.hpp.

template<class T>

bool Ipopt::CachedResults< T >::GetCachedResult2Dep | ( | T & | retResult,
|  | const TaggedObject * | dependent1,
|  | const TaggedObject * | dependent2 |
| ) |  |  | `[inline]`

Method for retrieving a cached result, proving two dependencies as a TaggedObject explicitly.

Definition at line 636 of file IpCachedResults.hpp.

template<class T>

void Ipopt::CachedResults< T >::AddCachedResult3Dep | ( | const T & | result,
|  | const TaggedObject * | dependent1,
|  | const TaggedObject * | dependent2,
|  | const TaggedObject * | dependent3 |
| ) |  |  | `[inline]`

Method for adding a result to the cache, proving three dependencies as a TaggedObject explicitly.

Definition at line 650 of file IpCachedResults.hpp.

template<class T>

bool Ipopt::CachedResults< T >::GetCachedResult3Dep | ( | T & | retResult,
|  | const TaggedObject * | dependent1,
|  | const TaggedObject * | dependent2,
|  | const TaggedObject * | dependent3 |
| ) |  |  | `[inline]`

Method for retrieving a cached result, proving three dependencies as a TaggedObject explicitly.

Definition at line 668 of file IpCachedResults.hpp.

template<class T>

bool Ipopt::CachedResults< T >::GetCachedResult1Dep | ( | T & | retResult,
|  | const TaggedObject & | dependent1 |
| ) |  |  | `[inline]`

Definition at line 167 of file IpCachedResults.hpp.

template<class T>

bool Ipopt::CachedResults< T >::GetCachedResult2Dep | ( | T & | retResult,
|  | const TaggedObject & | dependent1,
|  | const TaggedObject & | dependent2 |
| ) |  |  | `[inline]`

Definition at line 171 of file IpCachedResults.hpp.

template<class T>

bool Ipopt::CachedResults< T >::GetCachedResult3Dep | ( | T & | retResult,
|  | const TaggedObject & | dependent1,
|  | const TaggedObject & | dependent2,
|  | const TaggedObject & | dependent3 |
| ) |  |  | `[inline]`

Definition at line 177 of file IpCachedResults.hpp.

template<class T>

void Ipopt::CachedResults< T >::AddCachedResult1Dep | ( | const T & | result,
|  | const TaggedObject & | dependent1 |
| ) |  |  | `[inline]`

Definition at line 184 of file IpCachedResults.hpp.

template<class T>

void Ipopt::CachedResults< T >::AddCachedResult2Dep | ( | const T & | result,
|  | const TaggedObject & | dependent1,
|  | const TaggedObject & | dependent2 |
| ) |  |  | `[inline]`

Definition at line 189 of file IpCachedResults.hpp.

template<class T>

void Ipopt::CachedResults< T >::AddCachedResult3Dep | ( | const T & | result,
|  | const TaggedObject & | dependent1,
|  | const TaggedObject & | dependent2,
|  | const TaggedObject & | dependent3 |
| ) |  |  | `[inline]`

Definition at line 195 of file IpCachedResults.hpp.

template<class T >

bool Ipopt::CachedResults< T >::InvalidateResult | ( | const std::vector< const TaggedObject * > & | dependents,
|  | const std::vector< Number > & | scalar_dependents |
| ) |  |  | `[inline]`

Invalidates the result for given dependencies.

Sets the stale flag for the corresponding cached result to true if it is found. Returns true, if the result was found.

Definition at line 685 of file IpCachedResults.hpp.

template<class T >

void Ipopt::CachedResults< T >::Clear | ( |  | ) | `[inline]`

Invalidates all cached results.

Definition at line 708 of file IpCachedResults.hpp.

template<class T >

void Ipopt::CachedResults< T >::Clear | ( | Int | max_cache_size | ) | `[inline]`

Invalidate all cached results and changes max_cache_size.

Definition at line 723 of file IpCachedResults.hpp.

template<class T>

void Ipopt::CachedResults< T >::operator= | ( | const CachedResults< T > & |  | ) | `[private]`

Overloaded Equals Operator.

template<class T >

void Ipopt::CachedResults< T >::CleanupInvalidatedResults | ( |  | ) | const`[inline, private]`

internal method for removing stale DependentResults from the list.

It is called at the beginning of every GetDependentResult method.

Definition at line 730 of file IpCachedResults.hpp.

template<class T >

void Ipopt::CachedResults< T >::DebugPrintCachedResults | ( |  | ) | const`[inline, private]`

Print list of currently cached results.

Definition at line 757 of file IpCachedResults.hpp.

## Member Data Documentation

template<class T>

Int Ipopt::CachedResults< T >::max_cache_size_`[private]`

maximum number of cached results

Definition at line 236 of file IpCachedResults.hpp.

template<class T>

std::list<DependentResult<T>*>* Ipopt::CachedResults< T >::cached_results_`[mutable, private]`

list of currently cached results.

Definition at line 239 of file IpCachedResults.hpp.

The documentation for this class was generated from the following file:

- src/Common/IpCachedResults.hpp

All Classes Files Functions Variables Typedefs Enumerations Enumerator Friends Defines